use std::io;
use std::process::Command;
use std::sync::atomic::AtomicBool;
use std::thread::sleep;
use std::time::Duration;

use rayon::prelude::*;

const IGNORE_LENGTH: &[usize] = &[60usize, 61usize];
static WAIT: AtomicBool = AtomicBool::new(false);

fn format_time(hour: i32, minute: i32) -> String {
    format!("{:02}:{:02}", hour, minute)
}

fn execute(cth: i32, ctm: i32, cfh: i32, cfm: i32, cph: i32, cpm: i32, i: usize) {
    while WAIT.load(std::sync::atomic::Ordering::SeqCst) {
        sleep(Duration::from_millis(50));
    }

    let to = format_time(cth, ctm);
    let fr = format_time(cfh, cfm);
    let pa = format_time(cph, cpm);
    let cmd = format!("./timars -f {} -t {} -p {}", fr, to, pa);

    let output = Command::new("sh")
        .arg("-c")
        .arg(&cmd)
        .output()
        .expect("Failed to execute command");

    let output_str = String::from_utf8_lossy(&output.stdout);
    if output.status.success() && IGNORE_LENGTH.contains(&output_str.len()) {
        if i % 53 == 0 {
            println!(
                "to: {} from: {} pause: {} => len: {}",
                to,
                fr,
                pa,
                output_str.len()
            );
        }
    } else {
        println!(
            "\n\
              {}\n\
              {}\n\
              ==================\n\
              SOMETHING UNUSUAL!\n\
              LEN: {}\n\
        ",
            cmd,
            output_str,
            output_str.len()
        );
        WAIT.store(true, std::sync::atomic::Ordering::SeqCst);
        let mut input = String::new();
        println!("Input anything to continue");
        io::stdin()
            .read_line(&mut input)
            .expect("Failed to read input");
        WAIT.store(false, std::sync::atomic::Ordering::SeqCst);
    }
}

fn main() {
    let cph = 13; // NOTE: fix pause to 1337 to make it faster
    let cpm = 37; // in a real ctf, this would be hinted at
    (0..23).into_par_iter().for_each(|cth| {
        let mut i = 0;
        for ctm in 0..60 {
            for cfh in 0..23 {
                for cfm in 0..60 {
                    // for cph in 0..23 {
                    // for cpm in 0..60 {
                    execute(cth, ctm, cfh, cfm, cph, cpm, i);
                    i += 1;
                    // }
                    // }
                }
            }
        }
    });
}
